import React, { Component, ElementType } from 'react';
export declare const classList: {
    list: string;
    listHeader: string;
    listSection: string;
    listItem: string;
    listItemAnchor: string;
    listItemFixed: string;
};
export declare const ListItem: ({ value, displayOption, disabled, light }: {
    value: any;
    displayOption?: ((d: any) => any) | undefined;
    disabled: any;
    light: any;
}) => React.JSX.Element;
interface DropdownListProps {
    options?: any[];
    allowCustomValues?: number;
    customClasses?: {
        listHeader?: string;
        listItem?: string;
        results?: string;
    };
    customValues?: any[];
    customListItemComponent?: ElementType;
    customListHeaderComponent?: ElementType;
    selectionIndex?: number;
    onOptionSelected?: Function;
    displayOption?: Function;
    defaultClassNames?: boolean;
    areResultsTruncated?: boolean;
    resultsTruncatedMessage?: string;
    listItemComponent?: Function;
    light?: boolean;
    fixedOptions?: any[];
}
interface DropdownListState {
    options: Array<any> | null;
}
export default class DropdownList extends Component<DropdownListProps, DropdownListState> {
    static defaultProps: {
        customClasses: {};
        customListItemComponent: ({ value, displayOption, disabled, light }: {
            value: any;
            displayOption?: ((d: any) => any) | undefined;
            disabled: any;
            light: any;
        }) => React.JSX.Element;
        customListHeaderComponent: null;
        allowCustomValues: number;
        customValues: never[];
        displayOption: (d: any) => any;
        onOptionSelected: () => void;
        defaultClassNames: boolean;
        selectionIndex: null;
    };
    initNumberOfOptions: number;
    page: number;
    prevY: number;
    loadingRef: React.RefObject<HTMLDivElement>;
    observer: IntersectionObserver | undefined;
    constructor(props: any);
    componentDidMount(): void;
    getSnapshotBeforeUpdate(prevProps: DropdownListProps, prevState: DropdownListState): null;
    componentDidUpdate(prevProps: any, prevState: any, snapshot: any): void;
    componentWillUnmount(): void;
    handleObserver: (entities: any) => void;
    _getOptions(page: any): any[] | null;
    _onClick(result: any, event: any): void;
    render(): React.JSX.Element;
}
export {};
