import { ComponentType, ElementType } from 'react';
import RangePlotFactory from './range-plot';
import { LineChart, Filter } from '@kepler.gl/types';
import { Datasets } from '@kepler.gl/table';
interface RangeSliderProps {
    range?: number[];
    value0: number;
    value1: number;
    onChange?: (val: number[], e?: Event | null) => void;
    histogram?: any[];
    isRanged?: boolean;
    isEnlarged?: boolean;
    showInput?: boolean;
    inputTheme?: string;
    inputSize?: string;
    step?: number;
    sliderHandleWidth?: number;
    xAxis?: ElementType;
    timezone?: string | null;
    timeFormat?: string;
    playbackControlWidth?: number;
    lineChart?: LineChart;
    marks?: number[];
    plotType?: string;
    plotValue?: number[];
    animationWindow?: string;
    filter?: Filter;
    datasets?: Datasets;
}
declare function RangeSliderFactory(RangePlot: ReturnType<typeof RangePlotFactory>): ComponentType<RangeSliderProps>;
declare namespace RangeSliderFactory {
    var deps: (typeof RangePlotFactory)[];
}
export default RangeSliderFactory;
