import React from 'react';
import { IntlShape } from 'react-intl';
import { VisStateActions } from '@kepler.gl/actions';
import { Effect } from '@kepler.gl/types';
import SidePanelTitleFactory from './side-panel-title';
import EffectListFactory from './effect-list';
import EffectTypeSelectorFactory from './effect-type-selector';
export declare type EffectManagerState = {
    visStateActions: typeof VisStateActions;
    effects: Effect[];
    effectOrder: string[];
    children: React.ReactNode;
};
export declare type EffectManagerProps = {};
export declare type EffectManagerWithIntlProp = {
    intl: IntlShape;
};
declare function EffectManagerFactory(EffectList: ReturnType<typeof EffectListFactory>, SidePanelTitle: ReturnType<typeof SidePanelTitleFactory>, EffectTypeSelector: ReturnType<typeof EffectTypeSelectorFactory>): React.FC<EffectManagerProps>;
declare namespace EffectManagerFactory {
    var deps: ((() => React.FC<import("./side-panel-title").PanelTitleProps>) | typeof EffectListFactory | typeof EffectTypeSelectorFactory)[];
}
export default EffectManagerFactory;
