import React from 'react';
import { LightAndShadowEffectTimeMode } from '@kepler.gl/constants';
import TimezoneSelectorFactory from './timezone-selector';
import EffectTimeSliderFactory from './effect-time-slider';
import EffectTimeSelectorFactory from './effect-time-selector';
export declare type EffectTimeConfiguratorProps = {
    timestamp: number;
    timezone: string;
    timeMode: LightAndShadowEffectTimeMode;
    onChange: (parameters: {
        timestamp?: number | null;
        timezone?: string;
        timeMode?: LightAndShadowEffectTimeMode;
    }) => void;
};
declare function EffectTimeConfiguratorFactory(TimezoneSelector: ReturnType<typeof TimezoneSelectorFactory>, EffectTimeSlider: ReturnType<typeof EffectTimeSliderFactory>, EffectTimeSelector: ReturnType<typeof EffectTimeSelectorFactory>): React.FC<EffectTimeConfiguratorProps>;
declare namespace EffectTimeConfiguratorFactory {
    var deps: (typeof TimezoneSelectorFactory | typeof EffectTimeSliderFactory | typeof EffectTimeSelectorFactory)[];
}
export default EffectTimeConfiguratorFactory;
