import React from 'react';
import RangeSliderFactory from '../common/range-slider';
export declare type EffectTimeSliderConfig = {
    dawn: number;
    sunrise: number;
    sunset: number;
    dusk: number;
    sunriseTime: string;
    sunsetTime: string;
};
export declare type UIBlock = {
    type: string;
    width: number;
    center: number;
    start: number;
    end: number;
    text?: string;
    TopRowIcon?: React.ElementType<any>;
    BottomRowIcon?: React.ElementType<any>;
};
export declare type EffectTimeSliderProps = {
    value: number;
    onChange: (number: any) => void;
    config: EffectTimeSliderConfig;
};
/**
 * Generate rendering blocks for each part of the day.
 */
export declare function getUIBlocks(config: EffectTimeSliderConfig): UIBlock[];
declare function EffectTimeSliderFactory(RangeSlider: ReturnType<typeof RangeSliderFactory>): React.FC<EffectTimeSliderProps>;
declare namespace EffectTimeSliderFactory {
    var deps: (typeof RangeSliderFactory)[];
}
export default EffectTimeSliderFactory;
