import React from 'react';
import MapPopoverContentFactory from './map-popover-content';
import { IntlShape } from 'react-intl';
import { LayerHoverProp } from '@kepler.gl/reducers';
import { Feature, FeatureSelectionContext } from '@kepler.gl/types';
export declare function getSelectedFeature(layerHoverProp: LayerHoverProp | null): Feature | null;
export declare type MapPopoverProps = {
    x: number;
    y: number;
    frozen?: boolean;
    coordinate: [number, number] | boolean;
    layerHoverProp: LayerHoverProp | null;
    isBase?: boolean;
    zoom: number;
    container?: HTMLElement | null;
    onClose: () => void;
    onSetFeatures: (features: Feature[]) => any;
    setSelectedFeature: (feature: Feature | null, clickContext?: FeatureSelectionContext) => any;
    featureCollection?: {
        type: string;
        features: Feature[];
    };
};
declare type IntlProps = {
    intl: IntlShape;
};
declare function MapPopoverFactory(MapPopoverContent: ReturnType<typeof MapPopoverContentFactory>): React.FC<import("react-intl").WithIntlProps<MapPopoverProps & IntlProps>> & {
    WrappedComponent: React.ComponentType<MapPopoverProps & IntlProps>;
};
declare namespace MapPopoverFactory {
    var deps: (typeof MapPopoverContentFactory)[];
}
export default MapPopoverFactory;
