import React from 'react';
import { SetExportImageSettingUpdaterAction } from '@kepler.gl/actions';
import { Provider } from '@kepler.gl/cloud-providers';
export declare type ImageModalContainerProps = {
    provider?: Provider | null;
    onUpdateImageSetting: (newSetting: SetExportImageSettingUpdaterAction['payload']) => void;
    cleanupExportImage: () => void;
    children?: React.ReactNode;
};
/**
 * A wrapper component in modals contain a image preview of the map with cloud providers
 * It sets export image size based on provider thumbnail size
 * @type {React.FunctionComponent<ImageModalContainerProps>}
 */
declare const ImageModalContainer: React.FC<ImageModalContainerProps>;
export default ImageModalContainer;
