import React from 'react';
import { ImageModalContainerProps } from './image-modal-container';
import { ExportImage } from '@kepler.gl/constants';
import { MapInfo } from '@kepler.gl/types';
import { Provider } from '@kepler.gl/cloud-providers';
import { setMapInfo, cleanupExportImage as cleanupExportImageAction } from '@kepler.gl/actions';
declare type CharacterLimits = {
    title?: number;
    description?: number;
};
declare type SaveMapModalProps = {
    mapInfo: MapInfo;
    exportImage: ExportImage;
    isProviderLoading: boolean;
    providerError?: Error;
    characterLimits?: CharacterLimits;
    onUpdateImageSetting: ImageModalContainerProps['onUpdateImageSetting'];
    cleanupExportImage: typeof cleanupExportImageAction;
    onSetMapInfo: typeof setMapInfo;
    onConfirm: (provider: Provider) => void;
    onCancel: () => void;
};
declare type MapInfoPanelProps = Pick<SaveMapModalProps, 'mapInfo' | 'characterLimits'> & {
    onChangeInput: (type: string, event: React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>) => void;
};
export declare const MapInfoPanel: React.FC<MapInfoPanelProps>;
declare function SaveMapModalFactory(): React.FC<SaveMapModalProps>;
export default SaveMapModalFactory;
