import React from 'react';
import SidebarFactory from './side-panel/side-bar';
import PanelHeaderFactory from './side-panel/panel-header';
import PanelToggleFactory from './side-panel/panel-toggle';
import LayerManagerFactory from './side-panel/layer-manager';
import FilterManagerFactory from './side-panel/filter-manager';
import InteractionManagerFactory from './side-panel/interaction-manager';
import MapManagerFactory from './side-panel/map-manager';
import CustomPanelsFactory from './side-panel/custom-panel';
import { SidePanelProps } from './types';
export declare const StyledSidePanelContent: import("styled-components").StyledComponent<"div", any, {}, never>;
/**
 * Vertical sidebar containing input components for the rendering layers
 */
declare function SidePanelFactory(Sidebar: ReturnType<typeof SidebarFactory>, PanelHeader: ReturnType<typeof PanelHeaderFactory>, PanelToggle: ReturnType<typeof PanelToggleFactory>, LayerManager: ReturnType<typeof LayerManagerFactory>, FilterManager: ReturnType<typeof FilterManagerFactory>, InteractionManager: ReturnType<typeof InteractionManagerFactory>, MapManager: ReturnType<typeof MapManagerFactory>, CustomPanels: ReturnType<typeof CustomPanelsFactory>): React.FC<SidePanelProps>;
declare namespace SidePanelFactory {
    var deps: (typeof SidebarFactory | typeof PanelHeaderFactory | typeof PanelToggleFactory | typeof CustomPanelsFactory | typeof LayerManagerFactory | typeof FilterManagerFactory | typeof InteractionManagerFactory | typeof MapManagerFactory)[];
}
export default SidePanelFactory;
