import React from 'react';
import DatasetTagFactory from './dataset-tag';
import { openDeleteModal, VisStateActions, ActionHandler } from '@kepler.gl/actions';
import { RGBColor } from '@kepler.gl/types';
declare type MiniDataset = {
    id: string;
    color: RGBColor;
    label?: string;
};
export declare type DatasetTitleProps = {
    dataset: MiniDataset;
    showDeleteDataset: boolean;
    onTitleClick?: () => void;
    showDatasetTable?: ActionHandler<typeof VisStateActions.showDatasetTable>;
    updateTableColor: ActionHandler<typeof VisStateActions.updateTableColor>;
    removeDataset?: ActionHandler<typeof openDeleteModal>;
};
declare function DatasetTitleFactory(DatasetTag: ReturnType<typeof DatasetTagFactory>): React.FC<DatasetTitleProps>;
declare namespace DatasetTitleFactory {
    var deps: (typeof DatasetTagFactory)[];
}
export default DatasetTitleFactory;
