import React from 'react';
import { openDeleteModal, VisStateActions, ActionHandler } from '@kepler.gl/actions';
import { RGBColor } from '@kepler.gl/types';
import KeplerTable from '@kepler.gl/table';
export declare type PanelMeta = {
    id: string;
    label: string;
    iconComponent: React.ElementType;
    onClick: null;
};
export declare type UpdateTableColorTypes = {
    id: string;
    children: React.ReactNode;
};
export declare type ShowDataTableProps = {
    id: string;
    showDatasetTable?: ActionHandler<typeof VisStateActions.showDatasetTable>;
};
export declare type RemoveDatasetProps = {
    datasetKey: string;
    removeDataset?: ActionHandler<typeof openDeleteModal>;
};
export declare type StyledDatasetTitleProps = {
    clickable: boolean;
};
export declare type DatasetItemProps = {
    value: KeplerTable;
};
export declare type SelectableDataset = {
    label?: string;
    id: string;
    color: RGBColor;
};
export declare type SourceDataSelectorProps = {
    dataId: string | string[] | null;
    datasets: {
        [id: string]: SelectableDataset;
    };
    disabled?: boolean;
    defaultValue?: string;
    inputTheme?: string;
    onSelect: (items: ReadonlyArray<string | number | boolean | object> | string | number | boolean | object | null) => void;
};
