import { ComponentType } from 'react';
import { ColorRange } from '@kepler.gl/constants';
import RangeSliderFactory from '../../common/range-slider';
import { NestedPartial, RGBColor, RGBAColor, ColorUI } from '@kepler.gl/types';
declare type ColorSelectorInputProps = {
    active: boolean;
    disabled?: boolean;
    inputTheme?: string;
};
export declare type ColorSet = {
    selectedColor: RGBColor | RGBAColor | ColorRange;
    setColor: (v: RGBColor | RGBAColor | ColorRange) => void;
    isRange?: boolean;
    label?: string;
};
declare type ColorSelectorProps = {
    colorSets: ColorSet[];
    colorUI?: ColorUI;
    inputTheme?: string;
    disabled?: boolean;
    useOpacity?: boolean;
    setColorUI?: (newConfig: NestedPartial<ColorUI>) => void;
};
export declare const ColorBlock: import("styled-components").StyledComponent<"div", any, {
    backgroundcolor: RGBColor;
}, never>;
export declare const ColorSelectorInput: import("styled-components").StyledComponent<"div", any, ColorSelectorInputProps, never>;
export declare const InputBoxContainer: import("styled-components").StyledComponent<"div", any, {}, never>;
declare function ColorSelectorFactory(RangeSlider: any): ComponentType<ColorSelectorProps>;
declare namespace ColorSelectorFactory {
    var deps: (typeof RangeSliderFactory)[];
}
export default ColorSelectorFactory;
