import React from 'react';
import { ColumnPairs, LayerColumns, LayerBaseConfig } from '@kepler.gl/layers';
import { FieldPair, Field } from '@kepler.gl/types';
import ColumnSelectorFactory from './column-selector';
import { MinimalField } from '../../common/field-selector';
export declare type LayerColumnConfigProps<FieldOption extends MinimalField> = {
    columns: LayerColumns;
    fields: FieldOption[];
    assignColumnPairs: (key: string, pair: string) => LayerColumns;
    assignColumn: (key: string, field: FieldOption) => LayerColumns;
    updateLayerConfig: (newConfig: Partial<LayerBaseConfig>) => void;
    columnPairs?: ColumnPairs | null;
    fieldPairs?: FieldPair[];
    columnLabels?: Record<string, string>;
};
export declare type EnhancedFieldPair = {
    name: string;
    type: 'point';
    pair: FieldPair['pair'];
};
declare function LayerColumnConfigFactory(ColumnSelector: ReturnType<typeof ColumnSelectorFactory>): React.FC<LayerColumnConfigProps<Field>>;
declare namespace LayerColumnConfigFactory {
    var deps: (typeof ColumnSelectorFactory)[];
}
export default LayerColumnConfigFactory;
