import React from 'react';
import MapStyleSelectorFactory from './map-style-panel/map-style-selector';
import LayerGroupSelectorFactory from './map-style-panel/map-layer-selector';
import PanelTitleFactory from '../side-panel/panel-title';
import { PanelMeta } from './common/types';
import { WrappedComponentProps } from 'react-intl';
import { MapStyle } from '@kepler.gl/reducers';
import { MapStyleActions } from '@kepler.gl/actions';
export declare type MapManagerProps = {
    mapStyle: MapStyle;
    mapStyleActions: {
        mapStyleChange: typeof MapStyleActions.mapStyleChange;
        mapConfigChange: typeof MapStyleActions.mapConfigChange;
        set3dBuildingColor: typeof MapStyleActions.set3dBuildingColor;
        setBackgroundColor: typeof MapStyleActions.setBackgroundColor;
        removeCustomMapStyle: typeof MapStyleActions.removeCustomMapStyle;
    };
    showAddMapStyleModal: () => void;
    panelMetadata: PanelMeta;
} & WrappedComponentProps;
declare function MapManagerFactory(MapStyleSelector: ReturnType<typeof MapStyleSelectorFactory>, LayerGroupSelector: ReturnType<typeof LayerGroupSelectorFactory>, PanelTitle: ReturnType<typeof PanelTitleFactory>): React.FC<import("react-intl").WithIntlProps<MapManagerProps>> & {
    WrappedComponent: React.ComponentType<MapManagerProps>;
};
declare namespace MapManagerFactory {
    var deps: ((() => React.FC<import("../side-panel/panel-title").PanelTitleProps>) | typeof MapStyleSelectorFactory | typeof LayerGroupSelectorFactory)[];
}
export default MapManagerFactory;
