import React from 'react';
import PanelHeaderActionFactory from '../panel-header-action';
import LayerGroupItemFactory, { LayerGroupItemActionIcons } from './map-layer-group-item';
import { VisibleLayerGroups } from '@kepler.gl/types';
import { DEFAULT_LAYER_GROUP } from '@kepler.gl/constants';
import { MapConfigChangeUpdaterAction, Set3dBuildingColorUpdaterAction, SetBackgroundColorUpdaterAction } from '@kepler.gl/actions';
import { MapStyle } from '@kepler.gl/reducers';
export declare type LayerGroupSelectorProps = {
    layers: VisibleLayerGroups;
    editableLayers: DEFAULT_LAYER_GROUP[];
    onChange: (payload: MapConfigChangeUpdaterAction['payload']) => void;
    topLayers: MapStyle['topLayerGroups'];
    threeDBuildingColor: MapStyle['threeDBuildingColor'];
    on3dBuildingColorChange: (pd: Set3dBuildingColorUpdaterAction['payload']) => void;
    backgroundColor: MapStyle['backgroundColor'];
    onBackgroundColorChange: (pd: SetBackgroundColorUpdaterAction['payload']) => void;
    actionIcons?: LayerGroupItemActionIcons;
};
declare function LayerGroupSelectorFactory(PanelHeaderAction: ReturnType<typeof PanelHeaderActionFactory>, LayerGroupItem: ReturnType<typeof LayerGroupItemFactory>): ({ layers, editableLayers, onChange, topLayers, threeDBuildingColor, on3dBuildingColorChange, backgroundColor, onBackgroundColorChange, actionIcons }: LayerGroupSelectorProps) => React.JSX.Element;
declare namespace LayerGroupSelectorFactory {
    var deps: (typeof PanelHeaderActionFactory | typeof LayerGroupItemFactory)[];
}
export default LayerGroupSelectorFactory;
