import { Effect as EffectInterface, EffectProps, EffectPropsPartial, EffectParameterDescription } from '@kepler.gl/types';
export declare class Effect implements EffectInterface {
    id: string;
    type: string;
    isEnabled: boolean;
    parameters: {
        [key: string]: any;
    };
    isConfigActive: boolean;
    isJsonEditorActive: boolean;
    deckEffect: any;
    _uiConfig: EffectParameterDescription[];
    constructor(props?: EffectPropsPartial);
    _initializeEffect(): void;
    getDefaultProps(props?: EffectPropsPartial): EffectProps;
    setProps(props: EffectPropsPartial): void;
    isValidToSave(): boolean;
    /**
     * Effect specific list of configurable parameters.
     * @returns All parameters are in preffered order.
     */
    getParameterDescriptions(): EffectParameterDescription[];
}
export default Effect;
