import { PostProcessEffect } from '@deck.gl/core/typed';
import { VisState } from '@kepler.gl/schemas';
import { MapState, Effect, EffectProps, EffectDescription } from '@kepler.gl/types';
export declare function computeDeckEffects({ visState, mapState }: {
    visState: VisState;
    mapState: MapState;
}): PostProcessEffect[];
/**
 * Always keep light & shadow effect at the top
 */
export declare const fixEffectOrder: (effects: Effect[], effectOrder: string[]) => string[];
export declare function reorderEffectOrder(effectOrder: string[], originEffectId: string, destinationEffectId: string): string[];
/**
 * Validates parameters for an effect, clamps numbers to allowed ranges
 * or applies default values in case of wrong non-numeric values.
 * All unknown properties aren't modified.
 * @param parameters Parameters candidate for an effect.
 * @param effectDescription Description of an effect.
 * @returns
 */
export declare function validateEffectParameters(parameters: {
    [key: string]: any;
} | undefined, effectDescription: EffectDescription['parameters']): EffectProps['parameters'];
