import React from 'react';
import TimeWidgetFactory from './filters/time-widget';
import { bottomWidgetSelector } from './kepler-gl';
import FilterAnimationControllerFactory from './filter-animation-controller';
import LayerAnimationControllerFactory from './layer-animation-controller';
import AnimationControlFactory from './common/animation-control/animation-control';
export declare type BottomWidgetProps = {
    rootRef: React.ForwardedRef<HTMLDivElement>;
    containerW: number;
} & ReturnType<typeof bottomWidgetSelector>;
declare type ThemeProp = {
    theme: Record<string, any>;
};
declare type BottomWidgetThemedProps = BottomWidgetProps & ThemeProp;
declare function BottomWidgetFactory(TimeWidget: ReturnType<typeof TimeWidgetFactory>, AnimationControl: ReturnType<typeof AnimationControlFactory>, FilterAnimationController: ReturnType<typeof FilterAnimationControllerFactory>, LayerAnimationController: ReturnType<typeof LayerAnimationControllerFactory>): React.FC<BottomWidgetThemedProps>;
declare namespace BottomWidgetFactory {
    var deps: (typeof AnimationControlFactory | typeof TimeWidgetFactory | typeof LayerAnimationControllerFactory | typeof FilterAnimationControllerFactory)[];
}
export default BottomWidgetFactory;
