import React from 'react';
import { Timeline } from '@kepler.gl/types';
import TimelineSliderFactory from '../timeline-slider';
import PlaybackControlsFactory from './playback-controls';
import FloatingTimeDisplayFactory from './floating-time-display';
export declare type AnimationControlProps = {
    timeline?: Timeline;
    isAnimatable?: boolean;
    isAnimating?: boolean;
    updateAnimationSpeed?: (val: number) => void;
    setAnimationWindow?: (id: string) => void;
    toggleAnimation: () => void;
    resetAnimation?: () => void;
    setTimelineValue: (value: number[]) => void;
    showTimeDisplay?: boolean;
    showTimeline?: boolean;
    showControls?: boolean;
    className?: string;
    style?: object;
};
declare function AnimationControlFactory(PlaybackControls: ReturnType<typeof PlaybackControlsFactory>, FloatingTimeDisplay: ReturnType<typeof FloatingTimeDisplayFactory>, TimelineSlider: ReturnType<typeof TimelineSliderFactory>): React.FC<AnimationControlProps>;
declare namespace AnimationControlFactory {
    var deps: (typeof PlaybackControlsFactory | typeof TimelineSliderFactory | typeof FloatingTimeDisplayFactory)[];
}
export default AnimationControlFactory;
