import React, { ReactNode, ReactElement } from 'react';
import { Provider } from '@kepler.gl/cloud-providers';
declare const KeplerGlContext: React.Context<{
    selector: (state: any) => any;
    id: string;
}>;
export declare const FeatureFlagsContext: React.Context<object | null>;
export declare type FeatureFlags = {
    [key: string]: string | boolean;
};
export declare type FeatureFlagsContextProviderProps = {
    children: ReactNode;
    featureFlags?: FeatureFlags;
};
export declare type CloudProviderContextType = {
    provider: Provider | null;
    setProvider: (provider: Provider | null) => void;
    cloudProviders: Provider[];
};
export declare const FeatureFlagsContextProvider: (props: FeatureFlagsContextProviderProps) => ReactElement;
/**
 * This provides keeps track of the ist cloud providers
 * and the current selected one
 */
export declare const CloudProviderContext: React.Context<CloudProviderContextType>;
export declare const RootContext: React.Context<React.RefObject<HTMLDivElement> | null>;
export default KeplerGlContext;
