import React, { CSSProperties } from 'react';
import FeatureActionPanelFactory, { FeatureActionPanelProps } from './feature-action-panel';
import { Layer } from '@kepler.gl/layers';
import { Filter, FeatureSelectionContext, Feature } from '@kepler.gl/types';
import { Datasets } from '@kepler.gl/table';
interface EditorProps {
    filters: Filter[];
    layers: Layer[];
    datasets: Datasets;
    editor: {
        selectedFeature: Feature;
        mode: string;
        selectionContext?: FeatureSelectionContext;
    };
    index: number;
    className?: string;
    style: CSSProperties;
    onSelect: (f: Feature | null) => any;
    onSetEditorMode: (m: any) => void;
    onDeleteFeature: (f: Feature) => any;
    onTogglePolygonFilter: (l: Layer, f: Feature) => any;
}
export declare type PortalEditorProps = FeatureActionPanelProps & {
    visiblePanel: boolean;
    style?: React.CSSProperties;
};
declare function EditorFactory(FeatureActionPanel: React.FC<FeatureActionPanelProps>): React.ComponentClass<EditorProps>;
declare namespace EditorFactory {
    var deps: (typeof FeatureActionPanelFactory)[];
}
export default EditorFactory;
