import React from 'react';
import { MapViewState } from '@deck.gl/core/typed';
import { MapState } from '@kepler.gl/types';
export declare type MapViewStateContextType = {
    getInternalViewState: (index?: number) => MapViewState;
    setInternalViewState: (viewState: MapViewState, index?: number) => void;
};
export declare const MapViewStateContext: React.Context<MapViewStateContextType>;
/**
 * This context provider is used to localize the map view state so
 * that changes to the map view state do not affect the rest of the app,
 * mainly to prevent issues we experienced with basemap/deck viewport syncing.
 */
export declare const MapViewStateContextProvider: ({ mapState, children }: {
    mapState: MapState;
    children: React.ReactNode;
}) => React.JSX.Element;
