import React from 'react';
import DataTableFactory from '../common/data-table';
import KeplerTable, { Datasets } from '@kepler.gl/table';
import { UIStateActions } from '@kepler.gl/actions';
import { UiState } from '@kepler.gl/types';
import DataTableConfigFactory from '../common/data-table/display-format';
interface DatasetModalTabProps {
    active?: boolean;
}
export declare const DatasetModalTab: import("styled-components").StyledComponent<"div", any, DatasetModalTabProps, never>;
interface DatasetTabsUnmemoizedProps {
    activeDataset: KeplerTable;
    datasets: Datasets;
    showDatasetTable: (id: string) => void;
}
export declare const DatasetTabs: React.NamedExoticComponent<DatasetTabsUnmemoizedProps>;
interface DataTableModalProps {
    theme: any;
    dataId?: string;
    sortTableColumn: (id: string, column: string, mode?: string) => void;
    pinTableColumn: (id: string, column: string) => void;
    copyTableColumn: (id: string, column: string) => void;
    datasets: Datasets;
    showDatasetTable: (id: string) => void;
    showTab?: boolean;
    setColumnDisplayFormat: (dataId: string, formats: {
        column: string;
        displayFormat: string;
    }) => void;
    uiStateActions: typeof UIStateActions;
    uiState: UiState;
}
declare function DataTableModalFactory(DataTable: ReturnType<typeof DataTableFactory>, DataTableConfig: ReturnType<typeof DataTableConfigFactory>): React.ComponentType<Omit<DataTableModalProps, 'theme'>>;
declare namespace DataTableModalFactory {
    var deps: (typeof DataTableConfigFactory | typeof DataTableFactory)[];
}
export default DataTableModalFactory;
