import React from 'react';
import SourceDataCatalogFactory from './common/source-data-catalog';
import FilterPanelFactory from './filter-panel/filter-panel';
import { Filter } from '@kepler.gl/types';
import { Layer } from '@kepler.gl/layers';
import { VisStateActions, ActionHandler, UIStateActions, ActionHandlers } from '@kepler.gl/actions';
import { Datasets } from '@kepler.gl/table';
import PanelViewListToggleFactory from './panel-view-list-toggle';
import PanelTitleFactory from './panel-title';
import AddFilterButtonFactory from './filter-panel/add-filter-button';
import DatasetSectionFactory from './layer-panel/dataset-section';
import { PanelMeta } from './common/types';
declare type VisStateActionHandlers = ActionHandlers<typeof VisStateActions>;
declare type UiStateActionHandlers = ActionHandlers<typeof UIStateActions>;
export declare type FilterManagerProps = {
    filters: Filter[];
    datasets: Datasets;
    layers: Layer[];
    showDatasetTable: ActionHandler<typeof VisStateActions.showDatasetTable>;
    updateTableColor: ActionHandler<typeof VisStateActions.updateTableColor>;
    removeDataset: ActionHandler<typeof VisStateActions.removeDataset>;
    showAddDataModal: () => void;
    panelMetadata: PanelMeta;
    panelListView: string;
    visStateActions: VisStateActionHandlers;
    uiStateActions: UiStateActionHandlers;
};
declare function FilterManagerFactory(DatasetSection: ReturnType<typeof DatasetSectionFactory>, FilterPanel: ReturnType<typeof FilterPanelFactory>, PanelTitle: ReturnType<typeof PanelTitleFactory>, AddFilterButton: ReturnType<typeof AddFilterButtonFactory>, PanelViewListToggle: ReturnType<typeof PanelViewListToggleFactory>, SourceDataCatalog: ReturnType<typeof SourceDataCatalogFactory>): React.FC<FilterManagerProps>;
declare namespace FilterManagerFactory {
    var deps: (typeof SourceDataCatalogFactory | typeof PanelViewListToggleFactory | (() => React.FC<import("./panel-title").PanelTitleProps>) | typeof DatasetSectionFactory | typeof FilterPanelFactory | typeof AddFilterButtonFactory)[];
}
export default FilterManagerFactory;
