import React, { ComponentType } from 'react';
import PanelHeaderActionFactory from '../../side-panel/panel-header-action';
import { StyledPanelHeaderProps } from '../../common/styled-components';
import { RGBColor, Filter } from '@kepler.gl/types';
import { KeplerTable } from '@kepler.gl/table';
interface StyledFilterHeaderProps extends StyledPanelHeaderProps {
    $labelRCGColorValues: RGBColor[];
}
export declare const StyledFilterHeader: import("styled-components").StyledComponent<"div", any, StyledPanelHeaderProps & StyledFilterHeaderProps, never>;
export declare type FilterPanelHeaderProps = {
    className?: string;
    datasets: KeplerTable[];
    filter: Filter;
    removeFilter: () => void;
    actionIcons?: {
        delete: ComponentType;
    };
    children: React.ReactNode;
};
declare function FilterPanelHeaderFactory(PanelHeaderAction: ReturnType<typeof PanelHeaderActionFactory>): React.ComponentType<FilterPanelHeaderProps>;
declare namespace FilterPanelHeaderFactory {
    var deps: (typeof PanelHeaderActionFactory)[];
}
export default FilterPanelHeaderFactory;
