import { ComponentType } from 'react';
import { DraggableAttributes } from '@dnd-kit/core';
import { Transform } from '@dnd-kit/utilities';
import { TooltipFields } from '@kepler.gl/types';
interface TooltipChickletProps {
    disabled: boolean;
    item: {
        name: string;
    };
    displayOption: Function;
    remove: any;
    attributes: DraggableAttributes;
    listeners: any;
    setNodeRef: (node: HTMLElement | null) => void;
    transform: Transform | null;
    transition?: string;
    isDragging: boolean;
}
declare type TooltipConfig = {
    fieldsToShow: {
        [key: string]: {
            name: string;
            format: string | null;
        }[];
    };
    compareMode: boolean;
    compareType: string | null;
};
declare function TooltipChickletFactory(dataId: string, config: TooltipConfig, onChange: (cfg: TooltipConfig) => void, fields: TooltipFields[], onDisplayFormatChange: any): ComponentType<TooltipChickletProps>;
export default TooltipChickletFactory;
