import React from 'react';
import ColorSelectorFactory from './color-selector';
import LayerConfigGroupFactory from './layer-config-group';
import RangeSliderFactory from '../../common/range-slider';
import FieldSelectorFactory from '../../common/field-selector';
import { LayerTextLabel, Field } from '@kepler.gl/types';
declare type TextLabelPanelProps = {
    id?: string;
    fields: Field[];
    textLabel: LayerTextLabel[];
    updateLayerTextLabel: (idx: number | 'all', prop: string, value: any) => void;
};
declare function TextLabelPanelFactory(RangeSlider: ReturnType<typeof RangeSliderFactory>, LayerConfigGroup: ReturnType<typeof LayerConfigGroupFactory>, FieldSelector: ReturnType<typeof FieldSelectorFactory>, ColorSelector: ReturnType<typeof ColorSelectorFactory>): React.ComponentType<TextLabelPanelProps>;
declare namespace TextLabelPanelFactory {
    var deps: (typeof RangeSliderFactory | typeof FieldSelectorFactory | typeof LayerConfigGroupFactory | typeof ColorSelectorFactory)[];
}
export default TextLabelPanelFactory;
