import React from 'react';
import { RGBColor } from '@kepler.gl/types';
import { MapConfigChangeUpdaterAction } from '@kepler.gl/actions';
import { MapStyle } from '@kepler.gl/reducers';
import LayerGroupColorPickerFactory from './map-layer-group-color-picker';
import { PanelHeaderActionProps, PanelHeaderActionIcon } from '../panel-header-action';
export declare type LayerGroupItemActionIcons = {
    visible: PanelHeaderActionIcon;
    hidden: PanelHeaderActionIcon;
    top: PanelHeaderActionIcon;
};
export declare type LayerGroupItemProps = {
    PanelHeaderAction: React.FC<PanelHeaderActionProps>;
    onChange: (pd: MapConfigChangeUpdaterAction['payload']) => void;
    slug: string;
    layers: MapStyle['visibleLayerGroups'];
    topLayers: MapStyle['topLayerGroups'];
    actionIcons: LayerGroupItemActionIcons;
    color: RGBColor | null;
    onColorChange: (pd: RGBColor) => void;
    isVisibilityToggleAvailable?: boolean;
    isMoveToTopAvailable?: boolean;
    isColorPickerAvailable?: boolean;
};
declare function LayerGroupItemFactory(LayerGroupColorPicker: any): React.FC<LayerGroupItemProps>;
declare namespace LayerGroupItemFactory {
    var deps: (typeof LayerGroupColorPickerFactory)[];
}
export default LayerGroupItemFactory;
