import React, { ComponentType } from 'react';
import { MapStyle } from '@kepler.gl/reducers';
import PanelHeaderActionFactory from '../panel-header-action';
import { BaseProps } from '../../common/icons';
import { PanelHeaderActionIcon } from '../panel-header-action';
export declare type MapStyleSelectorProps = {
    mapStyle: MapStyle;
    onChange: (payload: string) => void;
    toggleActive: () => void;
    isSelecting: boolean;
    customMapStylesActions?: Record<string, {
        id: string;
        IconComponent: PanelHeaderActionIcon;
        tooltip: string;
        onClick: () => void;
    }[]>;
    actionIcons?: Record<string, ComponentType<Partial<BaseProps>>>;
};
declare function MapStyleSelectorFactory(PanelHeaderAction: ReturnType<typeof PanelHeaderActionFactory>): ({ mapStyle, onChange, toggleActive, isSelecting, customMapStylesActions, actionIcons }: MapStyleSelectorProps) => React.JSX.Element;
declare namespace MapStyleSelectorFactory {
    var deps: (typeof PanelHeaderActionFactory)[];
}
export default MapStyleSelectorFactory;
