import { CompositeLayer } from '@deck.gl/core/typed';
import { TileLayer as DeckGLTileLayer } from '@deck.gl/geo-layers/typed';
import { SolidPolygonLayer, SolidPolygonLayerProps } from '@deck.gl/layers/typed';
import { ThreeDBuildingLayerProps, TileDataItem, TileLoadProps } from './types';
export default class ThreeDBuildingLayer extends CompositeLayer<ThreeDBuildingLayerProps> {
    renderSubLayers(props: SolidPolygonLayerProps<any>): SolidPolygonLayer<TileDataItem, {}>;
    renderLayers(): DeckGLTileLayer<any, {
        id: string;
        getTileData: (tile: TileLoadProps) => Promise<TileDataItem[]>;
        minZoom: 13;
        renderSubLayers: (props: SolidPolygonLayerProps<any>) => SolidPolygonLayer<TileDataItem, {}>;
        updateTriggers: {
            getFillColor: import("@kepler.gl/types").RGBColor;
        } & Record<string, any>;
    }>[];
}
