/// <reference types="@danmarshall/deckgl-typings/deck.gl__core" />
import { LightingEffect } from '@deck.gl/core';
/**
 * Inserts shader code before detected part.
 * @param {string} vs Original shader code.
 * @param {string} type Debug string.
 * @param {string} insertBeforeText Text chunk to insert before.
 * @param {string} textToInsert Text to insert.
 * @returns Modified shader code.
 */
export declare function insertBefore(vs: any, type: any, insertBeforeText: any, textToInsert: any): any;
/**
 * Custom LightingEffect
 * 1) adds CustomShadowModule
 * 2) pass outputUniformShadow as module parameters
 * 3) properly removes CustomShadowModule
 */
declare class CustomDeckLightingEffect extends LightingEffect {
    constructor(props: any);
    preRender(gl: any, { layers, layerFilter, viewports, onViewportActive, views }: {
        layers: any;
        layerFilter: any;
        viewports: any;
        onViewportActive: any;
        views: any;
    }): void;
    getModuleParameters(layer: any): {
        shadowMaps: any;
        dummyShadowMap: any;
        shadowColor: any;
        shadowMatrices: any;
    } | {
        shadowMaps?: undefined;
        dummyShadowMap?: undefined;
        shadowColor?: undefined;
        shadowMatrices?: undefined;
    };
    cleanup(): void;
}
export default CustomDeckLightingEffect;
