import { Layer as DeckLayer, LayerProps as DeckLayerProps } from '@deck.gl/core/typed';
import { Viewport, Editor, Feature, FeatureSelectionContext } from '@kepler.gl/types';
export declare type GetEditorLayerProps = {
    editorMenuActive: boolean;
    editor: Editor;
    onSetFeatures: (features: Feature[]) => any;
    setSelectedFeature: (feature: Feature | null, selectionContext?: FeatureSelectionContext) => any;
    viewport: Viewport;
    featureCollection: {
        type: string;
        features: Feature[];
    };
    selectedFeatureIndexes: number[];
};
/**
 * Returns editable layer to edit polygon filters.
 * @param params
 * @param params.editorMenuActive Indicates whether the editor side menu is active.
 * @param params.editor
 * @param params.onSetFeatures A callback to set features.
 * @param params.setSelectedFeature A callback to set selected feature and selection context.
 * @param params.viewport Current viewport.
 * @param params.featureCollection Feature collection with an array of features
 * @param params.selectedFeatureIndexes An array with index of currently selected feature.
 */
export declare function getEditorLayer({ editorMenuActive, editor, onSetFeatures, setSelectedFeature, featureCollection, selectedFeatureIndexes, viewport }: GetEditorLayerProps): DeckLayer<DeckLayerProps>;
