export declare type Notification = Record<string, any> & {
    id: string;
    message: string;
    type: 'info' | 'error' | 'warning' | 'success';
    topic: 'global' | 'file';
    count: number;
};
/**
 * Creates a notification
 */
export declare function createNotification({ message, type, topic, id, count, ...options }: Partial<Notification>): Notification;
/**
 * Creates an error notification
 * @param options
 * @returns {{topic, id, message, type: (null|number)}}
 */
export declare const errorNotification: (options: any) => {
    type: "error";
    id: string;
    message: string;
    topic: 'global' | 'file';
    count: number;
};
/**
 * Creates a success notification
 * @param options
 * @returns {{topic, id, message, type: null}}
 */
export declare const successNotification: (options: any) => {
    type: "success";
    id: string;
    message: string;
    topic: 'global' | 'file';
    count: number;
};
export declare const exportImageError: (options: any) => {
    type: "error";
    id: string;
    message: string;
    topic: 'global' | 'file';
    count: number;
};
